// Convert_SI.h


// =====================================================================
double H_Air_SI( double P, double T );
double H_Argon_SI( double P, double T );
double H_Nitrogen_SI( double P, double T );
double H_CarbDiox_SI( double P, double T );
double H_Water_SI( double P, double T );
double H_Steam_SI( double P, double T );

double H_Ammonia_SI( double P, double T );
double H_Butane_SI( double P, double T );
double H_Ethane_SI( double P, double T );
double H_Ethylene_SI( double P, double T );
double H_Hydrogen_SI( double P, double T );
double H_Methane_SI( double P, double T );
double H_Octane_SI( double P, double T );
double H_Oxygen_SI( double P, double T );
double H_Propane_SI( double P, double T );



// =====================================================================
double S_Air_SI( double P, double T );
double S_Argon_SI( double P, double T );
double S_Nitrogen_SI( double P, double T );
double S_CarbDiox_SI( double P, double T );
double S_Water_SI( double P, double T );
double S_Steam_SI( double P, double T );

double S_Ammonia_SI( double P, double T );
double S_Butane_SI( double P, double T );
double S_Ethane_SI( double P, double T );
double S_Ethylene_SI( double P, double T );
double S_Hydrogen_SI( double P, double T );
double S_Methane_SI( double P, double T );
double S_Octane_SI( double P, double T );
double S_Oxygen_SI( double P, double T );
double S_Propane_SI( double P, double T );



// =====================================================================
double T_HP_Air_SI( double H, double P ); 
double T_HP_Nitrogen_SI( double H, double P ); 
double T_HP_Argon_SI( double H, double P ); 
double T_HP_CarbDiox_SI( double H, double P );
double T_HP_Ammonia_SI( double H, double P );
double T_HP_Butane_SI( double H, double P );
double T_HP_Ethane_SI( double H, double P );
double T_HP_Ethylene_SI( double H, double P );
double T_HP_Hydrogen_SI( double H, double P );
double T_HP_Methane_SI( double H, double P );
double T_HP_Octane_SI( double H, double P );
double T_HP_Oxygen_SI( double H, double P );
double T_HP_Propane_SI( double H, double P );
double T_HP_Water_SI( double H, double P);
double T_HP_Steam_SI( double H, double P );


double T_SP_Air_SI( double S, double P ); 
double T_SP_Nitrogen_SI( double S, double P ); 
double T_SP_Argon_SI( double S, double P ); 
double T_SP_CarbDiox_SI( double S, double P );
double T_SP_Ammonia_SI( double S, double P );
double T_SP_Butane_SI( double S, double P );
double T_SP_Ethane_SI( double S, double P );
double T_SP_Ethylene_SI( double S, double P );
double T_SP_Hydrogen_SI( double S, double P );
double T_SP_Methane_SI( double S, double P );
double T_SP_Octane_SI( double S, double P );
double T_SP_Oxygen_SI( double S, double P );
double T_SP_Propane_SI( double S, double P );
double T_SP_Water_SI( double S, double P);
double T_SP_Steam_SI( double S, double P );


double P_HT_Air_SI( double H, double T ); 
double P_HT_Nitrogen_SI( double H, double T ); 
double P_HT_Argon_SI( double H, double T );
double P_HT_CarbDiox_SI( double H, double T );
double P_HT_Ammonia_SI( double H, double T );
double P_HT_Butane_SI( double H, double T );
double P_HT_Ethane_SI( double H, double T );
double P_HT_Ethylene_SI( double H, double T );
double P_HT_Hydrogen_SI( double H, double T );
double P_HT_Methane_SI( double H, double T );
double P_HT_Octane_SI( double H, double T );
double P_HT_Oxygen_SI( double H, double T );
double P_HT_Propane_SI( double H, double T );
double P_HT_Water_SI( double H, double T );
double P_HT_Steam_SI( double H, double T );

double P_ST_Air_SI( double S, double T ); 
double P_ST_Nitrogen_SI( double S, double T ); 
double P_ST_Argon_SI( double S, double T );
double P_ST_CarbDiox_SI( double S, double T );
double P_ST_Ammonia_SI( double S, double T );
double P_ST_Butane_SI( double S, double T );
double P_ST_Ethane_SI( double S, double T );
double P_ST_Ethylene_SI( double S, double T );
double P_ST_Hydrogen_SI( double S, double T );
double P_ST_Methane_SI( double S, double T );
double P_ST_Octane_SI( double S, double T );
double P_ST_Oxygen_SI( double S, double T );
double P_ST_Propane_SI( double S, double T );
double P_ST_Water_SI( double S, double T );
double P_ST_Steam_SI( double S, double T );




// =====================================================================
double Tsat_Water_SI( double P );
double Psat_Water_SI( double T );
double rhosat_Water_SI( double T );
// =====================================================================


double P_Air_SI( double V, double T );
double P_Argon_SI( double V, double T );
double P_Nitrogen_SI( double V, double T );
double P_CarbDiox_SI( double V, double T );
double P_Water_SI( double V, double T );
double P_Ammonia_SI( double V, double T );
double P_Butane_SI( double V, double T );
double P_Ethane_SI( double V, double T );
double P_Ethylene_SI( double V, double T );
double P_Hydrogen_SI( double V, double T );
double P_Methane_SI( double V, double T );
double P_Octane_SI( double V, double T );
double P_Oxygen_SI( double V, double T );
double P_Propane_SI( double V, double T );



double V_Air_SI( double P, double T );
double V_Argon_SI( double P, double T );
double V_Nitrogen_SI( double P, double T );
double V_CarbDiox_SI( double P, double T );
double V_Steam_SI( double P, double T );
double V_Water_SI( double P, double T );

double V_Ammonia_SI( double P, double T );
double V_Butane_SI( double P, double T );
double V_Ethane_SI( double P, double T );
double V_Ethylene_SI( double P, double T );
double V_Hydrogen_SI( double P, double T );
double V_Methane_SI( double P, double T );
double V_Octane_SI( double P, double T );
double V_Oxygen_SI( double P, double T );
double V_Propane_SI( double P, double T );
// =====================================================================

double H_C5H12_SI( double P, double T );
double H_CO_SI( double P, double T );
double H_NO_SI( double P, double T );
double H_OH_SI( double P, double T );
double H_H_SI( double P, double T );
double H_O_SI( double P, double T );
double H_H2O_V_SI( double P, double T );


double S_C5H12_SI( double P, double T );
double S_CO_SI( double P, double T );
double S_NO_SI( double P, double T );
double S_OH_SI( double P, double T );
double S_H_SI( double P, double T );
double S_O_SI( double P, double T );
double S_H2O_V_SI( double P, double T );

double T_HP_C5H12_SI( double H, double P);
double T_HP_CO_SI( double H, double P );
double T_HP_NO_SI( double H, double P );
double T_HP_OH_SI( double H, double P );
double T_HP_H_SI( double H, double P );
double T_HP_O_SI( double H, double P );
double T_HP_H2O_V_SI( double H, double P );

double T_SP_C5H12_SI( double S, double P);
double T_SP_CO_SI( double S, double P );
double T_SP_NO_SI( double S, double P );
double T_SP_OH_SI( double S, double P );
double T_SP_H_SI( double S, double P );
double T_SP_O_SI( double S, double P );
double T_SP_H2O_V_SI( double S, double P );


// =====================================================================
double Mw_Products_SI( double HC_ratio, double PercentAir, double *CO2,
				    double *H2O, double *Air, double *Ar, double *N2 );
// =====================================================================
double H_Products_SI( double P, double T, double HydroCarb, double PercentStoi );
double S_Products_SI( double P, double T, double HydroCarb, double PercentStoi );
// =====================================================================
double TfromS_Products_SI( double P, double S, double HydroCarb, 
						double PercentStoi );
double TfromH_Products_SI( double P, double H, double HydroCarb, 
						double PercentStoi );


double Convert_to_English(double val,char property);
double Convert_to_SI(double val,char property);