
      SUBROUTINE COSTHE                                                 FIN18560
C     COST ESTIMATION FOR THE SUGGESTED HEAT EXCHANGER NETWORK          FIN18570
      DIMENSION ARRH(50,6),ARRC(50,6),ARRX(50,10),ARR9(12)              FIN18580
     *  ,HEX(50,11),HEXB(50,11),BHARC(50,7),BHARH(50,7)                 FIN18590
     *  ,CPC(50),CPH(50),FLOWC(50),FLOWH(50),TPIH(50),TPOH(50),
     *   TPIC(50),TPOC(50),STRNH(50),STRNC(50),FCH(50),FCC(50)
      COMMON/BHAR/BHARC,BHARH,IDUMH,IDUMC                               FIN18600
      COMMON/HTR/ARRH,MH                                                FIN18610
      COMMON/CLR/ARRC,MC                                                FIN18620
      COMMON/ALL/CPC,CPH,PIN,NW,MW,FLOWC,FLOWH,TPIH,TPOH,TPIC,TPOC,     FIN18630
     *FCH,FCC
      COMMON/INP1/STRNH,STRNC
      COMMON/LABEL3/ARRX,NHEX                                           FIN18640
      COMMON/HXR/HEX,NHEN,HEXB,NHENB                                    FIN18650
      COMMON/LABEL9/ARR9                                                FIN18660
      character*27 blanks  
      character*12 fname,namef,strnh,strnc 
C     SUBROUTINE COSTIN IS A SUBROUTINE TO  READ INPUT COSTS            FIN18680
C     IT CALLS ON GDDM GRAPHICS SUBROUTINES THAT WILL HAVE              FIN18690
C     TO BE CHANGED. DELETE THESE LINES OF COMMENT WHEN THE             FIN18700
C     CHANGES HAVE BEEN IMPLEMENTED.                                    FIN18710
      CALL COSTIN                                                       FIN18730
      NHEX=NHEN+NHENB                                                   FIN18740
      DO 400 I=1,NHEN                                                   FIN18750
      DO 400 J=1,10                                                     FIN18760
      ARRX(I,J)=HEX(I,J)                                                FIN18770
400   CONTINUE                                                          FIN18780
      DO 401 I=NHEN+1,NHEN+NHENB                                        FIN18790
      DO 401 J=1,10                                                     FIN18800
      ARRX(I,J)=HEXB(I-NHEN,J)                                          FIN18810
401   CONTINUE                                                          FIN18820
      CALL STECOS(COST1,COST7)                                          FIN18830
      CALL WATCOS(COST2,COST5)                                          FIN18840
      CALL HEXCOS(TOTHEX)                                               FIN18850
      TOTAL = COST1 + COST2 + TOTHEX + COST5 + COST7                    FIN18860
      WRITE(6,1)TOTAL                                                   FIN18870
    1 FORMAT(1H1,'THE TOTAL COST OF THE HEAT EXCHANGER NETWORK IS',     FIN18880
     +5X,'$ ',E10.3)                                                    FIN18890
      WRITE(6,2) COST1                                                  FIN18900
    2 FORMAT(1H+,'THE COST OF STEAM USED IS',5X,'$ ',E10.3)             FIN18910
      WRITE(6,3) COST5                                                  FIN18920
    3 FORMAT(1H+,'THE COST OF HEATERS USED IS',5X,'$ ',E10.3)           FIN18930
      WRITE(6,4) COST2                                                  FIN18940
    4 FORMAT(1H+,'THE COST OF COOLING WATER USED IS',5X,'$ ',E10.3)     FIN18950
      WRITE(6,5) COST7                                                  FIN18960
    5 FORMAT(1H+,'THE COST OF COOLERS USED IS',5X,'$ ',E10.3)           FIN18970
      WRITE(6,6) TOTHEX                                                 FIN18980
    6 FORMAT(1H+,'THE COST OF HEAT EXCHANGERS USED IS',5X,'$ ',E10.3)   FIN18990
      RETURN                                                            FIN19000
      END                                                               FIN19010
C     THIS SUBROUTINE IS CALLED BY SUBROUTINE COSTHE. IT ESTIMATES      FIN19030
C     THE COST OF THE STEAM.                                            FIN19040
      SUBROUTINE STECOS(COST1,COST7)                                    FIN19060
C     CALCULATION OF THE STEAM COST                                     FIN19070
      DIMENSION ARRH(50,6),ARR9(12)                                     FIN19080
      COMMON/HTR/ARRH,MH                                                FIN19090
      COMMON/LABEL9/ARR9                                                FIN19100
      COMMON/DELT/DELT                                                  FIN19110
      WHOURS = ARR9(10)                                                 FIN19120
      ZLATST = ARR9(3)                                                  FIN19130
      STCOST = ARR9(8)                                                  FIN19140
      TSTE = ARR9(2)-DELT/2                                             FIN19150
      UST = ARR9(6)                                                     FIN19160
      TOTST = 0.0                                                       FIN19170
      COST7 = 0.0                                                       FIN19180
      DO 10 I = 1,MH                                                    FIN19190
      Q1 = ARRH(I,3)                                                    FIN19200
      STEAM = Q1 / ZLATST                                               FIN19210
      TOTST = TOTST + STEAM                                             FIN19220
      IF((TSTE-ARRH(I,5)).LT.0.0) THEN                                  FIN19230
        WRITE(6,*)'THE HOT UTILITY IS AT A LOWER TEMPERATURE THAN THE'  FIN19240
        WRITE(6,*)'OUTLET TEMPERATURES OF SOME OF THE COLD STREAMS.'    FIN19250
        WRITE(6,*)'PLEASE SPECIFY A HIGHER HOT UTILITY TEMPERATURE.'    FIN19260
        RETURN                                                          FIN19270
      ENDIF                                                             FIN19280
      ZLMTD1= TSTE - ARRH(I,4)                                          FIN19290
      ZLMTD2= TSTE - ARRH(I,5)                                          FIN19300
      IF(ABS(ZLMTD1 - ZLMTD2).LT. 0.000001) THEN                        FIN19310
        ZLMTD = ZLMTD1                                                  FIN19320
      ELSE                                                              FIN19330
        ZLMTD = (ZLMTD1 - ZLMTD2)/ALOG(ZLMTD1/ZLMTD2)                   FIN19340
      ENDIF                                                             FIN19350
  811 AREA1 = Q1/UST/ZLMTD                                              FIN19360
      COST6 = ARR9(11) * AREA1 ** 0.5/ARR9(12)                          FIN19370
      COST7 = COST7 + COST6                                             FIN19380
   10 CONTINUE                                                          FIN19390
      COST1 = TOTST * STCOST                                            FIN19400
      COST1 = COST1 * WHOURS                                            FIN19410
      RETURN                                                            FIN19420
      END                                                               FIN19430
C     THIS SUBROUTINE IS CALLED BY SUBROUTINE COSTHE. IT ESTIMATES      FIN19450
C     THE COST OF THE COOLING WATER.                                    FIN19460
      SUBROUTINE WATCOS(COST2,COST5)                                    FIN19480
      DIMENSION ARRC(50,6),ARR9(12)                                     FIN19490
      COMMON/CLR/ARRC,MC                                                FIN19500
      COMMON/LABEL9/ARR9                                                FIN19510
      COMMON/DELT/DELT                                                  FIN19520
C     CALCULATION OF COOLING WATER COSTS                                FIN19530
      CPW = 4.2                                                         FIN19540
      TCWIN = ARR9(4)+DELT/2                                            FIN19550
      TCWOUT = ARR9(5)+DELT/2                                           FIN19560
      WACOST = ARR9(9)                                                  FIN19570
      UCOOL = ARR9(7)                                                   FIN19580
      DELTW = TCWOUT - TCWIN                                            FIN19590
      TOTWAT = 0.0                                                      FIN19600
      COST5 = 0.0                                                       FIN19610
      WHOURS=ARR9(10)                                                   FIN19620
      DO 20 I = 1,MC                                                    FIN19630
      WATER = ARRC(I,3) / CPW / DELTW                                   FIN19640
      TOTWAT = TOTWAT + WATER                                           FIN19650
      ZLMTD1= ARRC(I,4)-TCWOUT                                          FIN19660
      ZLMTD2= ARRC(I,5)-TCWIN                                           FIN19670
      IF(ZLMTD2.LT.0.) THEN                                             FIN19680
        WRITE(6,*)'THE OUTLET TEMPERATURES OF SOME OF THE HOT STREAMS'  FIN19690
        WRITE(6,*)'ARE LESS THAN THE SUPPLY TEMPERATURE OF THE COLD'    FIN19700
        WRITE(6,*)'UTILITY. PLEASE SPECIFY A LOWER COLD UTILITY'        FIN19710
        WRITE(6,*)'TEMPERATURE.'                                        FIN19720
        RETURN                                                          FIN19730
      ENDIF                                                             FIN19740
      IF((ZLMTD1-ZLMTD2).LT.0.001) THEN                                 FIN19750
        ZLMTD=ZLMTD1                                                    FIN19760
      ELSE                                                              FIN19770
        ZLMTD = (ZLMTD1 - ZLMTD2)/ALOG(ZLMTD1/ZLMTD2)                   FIN19780
      ENDIF                                                             FIN19790
      AREA2 = ARRC(I,3)/UCOOL/ZLMTD                                     FIN19800
      COST4 = ARR9(11)* AREA2 ** 0.5 /ARR9(12)                          FIN19810
      COST5 = COST5 + COST4                                             FIN19820
   20 CONTINUE                                                          FIN19830
      COST2 = TOTWAT * WACOST                                           FIN19840
      COST2 = COST2 * WHOURS                                            FIN19850
      RETURN                                                            FIN19860
      END                                                               FIN19870
C     THIS SUBROUTINE IS CALLED BY SUBROUTINE COSTHE. IT ESTIMATES      FIN19890
C     THE COST OF THE HEAT EXCHANGERS.                                  FIN19900
      SUBROUTINE HEXCOS(TOTHEX)                                         FIN19920
C     CALCULATION OF THE HEAT EXCHANGER COST                            FIN19930
      DIMENSION ARRX(50,10),ARR9(12)                                    FIN19940
      COMMON/LABEL3/ARRX,NHEX                                           FIN19950
      COMMON/LABEL9/ARR9                                                FIN19960
      COMMON/DELT/DELT                                                  FIN19970
      U = ARR9(6)                                                       FIN19980
      TOTHEX = 0.0                                                      FIN19990
      DO 30 I = 1,NHEX                                                  FIN20000
      ZLMTD1= ARRX(I,5)-ARRX(I,8)+DELT                                  FIN20010
      ZLMTD2= ARRX(I,6)-ARRX(I,7)+DELT                                  FIN20020
      ZLMTD3=ZLMTD1-ZLMTD2                                              FIN20030
      IF (ABS(ZLMTD3).LT.0.0001)  THEN                                  FIN20040
      ZLMTD = ZLMTD1                                                    FIN20050
      GOTO 11                                                           FIN20060
      ENDIF                                                             FIN20070
      ZLMTD = (ZLMTD1 - ZLMTD2)/ALOG(ZLMTD1/ZLMTD2)                     FIN20080
   11 AREA = ARRX(I,4)/U/ZLMTD                                          FIN20090
      COST3 = ARR9(11)* AREA ** 0.5/ARR9(12)                            FIN20100
      TOTHEX = TOTHEX + COST3                                           FIN20110
   30 CONTINUE                                                          FIN20120
      RETURN                                                            FIN20130
      END                                                               FIN20140
C     THIS SUBROUTINE IS CALLED BY SUBROUTINE COSTHE. IT DEFINES        FIN20160
C     DEFAULT INPUT DATA AND DISPLAYS THIS DATA USING GDDM ROUTINES.    FIN20170
C     IT ALSO ALLOWS CHANGES TO BE MADE IN THE DEFAULT DATA             FIN20180
C     INTERACTIVELY.                                                    FIN20190
      SUBROUTINE COSTIN                                                 FIN20210
      DIMENSION ARR(12),STR(50)                                         FIN20220
      COMMON/LABEL9/ARR                                                 FIN20230
c     CHARACTER*7 STR                                                   FIN20240
c     CHARACTER * 1 ANS                                                 FIN20250
c     CHARACTER * 2 ROW                                                 FIN20260
c     CALL GSWIN(0.,100.,0.,100.)                                       FIN20270
c     CALL GSCOL(4)                                                     FIN20280
c     CALL GSMOVE(3.,95.)                                               FIN20290
c     CALL GSLINE(95.,95.)                                              FIN20300
c     CALL GSMOVE(3.,85.)                                               FIN20310
c     CALL GSLINE(95.,85.)                                              FIN20320
c     CALL GSMOVE(3.,8.)                                                FIN20330
c     CALL GSLINE(95.,8.)                                               FIN20340
c     CALL GSMOVE(3.,95.)                                               FIN20350
c     CALL GSLINE(3.,8.)                                                FIN20360
c     CALL GSMOVE(10.,95.)                                              FIN20370
c     CALL GSLINE(10.,8.)                                               FIN20380
c     CALL GSMOVE(45.,95.)                                              FIN20390
c     CALL GSLINE(45.,8.)                                               FIN20400
c     CALL GSMOVE(95.,95.)                                              FIN20410
c     CALL GSLINE(95.,8.)                                               FIN20420
c     CALL ASDFLD(100,4,6,1,2,2)                                        FIN20430
C*    CALL ASCPUT(100,2,'NO')                                           FIN20440
c     CALL ASDFLD(200,4,17,1,9,2)                                       FIN20450
C*    CALL ASCPUT(200,9,'VARIABLES')                                    FIN20460
c     CALL ASDFLD(300,4,50,1,11,2)                                      FIN20470
C*    CALL ASCPUT(300,11,'DESIGN DATA')                                 FIN20480
c     DO 10 I = 1,12                                                    FIN20490
c     CALL ASDFLD(I,5+I*2,6,1,2,2)                                      FIN20500
c     CALL ASFCOL(I,2)                                                  FIN20510
c  10 CONTINUE                                                          FIN20520
c*    CALL ASCPUT(1,2,' 1')                                             FIN20530
c*    CALL ASCPUT(2,2,' 2')                                             FIN20540
c*    CALL ASCPUT(3,2,' 3')                                             FIN20550
c*    CALL ASCPUT(4,2,' 4')                                             FIN20560
c*    CALL ASCPUT(5,2,' 5')                                             FIN20570
c*    CALL ASCPUT(6,2,' 6')                                             FIN20580
c*    CALL ASCPUT(7,2,' 7')                                             FIN20590
c*    CALL ASCPUT(8,2,' 8')                                             FIN20600
c*    CALL ASCPUT(9,2,' 9')                                             FIN20610
c*    CALL ASCPUT(10,2,'10')                                            FIN20620
c*    CALL ASCPUT(11,2,'11')                                            FIN20630
c*    CALL ASCPUT(12,2,'12')                                            FIN20640
c     DO 20 I = 1,12                                                    FIN20650
c     CALL ASDFLD(12+I,5+I*2,11,1,25,2)                                 FIN20660
c     CALL ASFCOL(12+I,7)                                               FIN20670
c  20 CONTINUE                                                          FIN20680
c*    CALL ASCPUT(13,14,'STEAM PRESSURE')                               FIN20690
c*    CALL ASCPUT(14,17,'STEAM TEMPERATURE')                            FIN20700
c*    CALL ASCPUT(15,17,'STEAM LATENT HEAT')                            FIN20710
c*    CALL ASCPUT(16,24,'COOLANT (TEMPERATURE IN)')                     FIN20720
c*    CALL ASCPUT(17,25,'COOLANT (TEMPERATURE OUT)')                    FIN20730
c*    CALL ASCPUT(18,23,'OVERALL H/T COEFFICIENT')                      FIN20740
c*    CALL ASCPUT(19,2,'  ')                                            FIN20750
c*    CALL ASCPUT(20,13,'COST OF STEAM')                                FIN20760
c*    CALL ASCPUT(21,15,'COST OF COOLANT')                              FIN20770
cc    CALL ASCPUT(22,22,'EQUIPMENT AVAILIBILITY')                       FIN20780
c*    CALL ASCPUT(23,16,'COST OF H/T AREA')                             FIN20790
c*    CALL ASCPUT(24,19,'HEAT EXCHANGER LIFE')                          FIN20800
c     DO 30 I = 1,12                                                    FIN20810
c     CALL ASDFLD(24+I,5+I*2,39,1,07,0)                                 FIN20820
c     CALL ASFCOL(24+I,5)                                               FIN20830
c  30 CONTINUE                                                          FIN20840
c     DO 40 I = 1,12                                                    FIN20850
c     CALL ASDFLD(36+I,5+I*2,47,1,28,0)                                 FIN20860
c     CALL ASFCOL(36+I,6)                                               FIN20870
c  40 CONTINUE                                                          FIN20880
c*    CALL ASCPUT(37,4,'BARS')                                          FIN20890
c*    CALL ASCPUT(38,5,'DEG C')                                         FIN20900
c*    CALL ASCPUT(39,5,'KJ/KG')                                         FIN20910
c*    CALL ASCPUT(40,5,'DEG C')                                         FIN20920
c*    CALL ASCPUT(41,5,'DEG C')                                         FIN20930
c*    CALL ASCPUT(42,21,'W/M+2/DEG K (HEATERS)')                        FIN20940
c*    CALL ASCPUT(43,28,'W/M+2/DEG K (EXCH & COOLERS)')                 FIN20950
c*    CALL ASCPUT(44,4,'$/KG')                                          FIN20960
c*    CALL ASCPUT(45,4,'$/KG')                                          FIN20970
c*    CALL ASCPUT(46,5,'HR/YR')                                         FIN20980
c*    CALL ASCPUT(47,27,'(AREA)**0.5 $ (AREA IN M+2)')                  FIN20990
c*    CALL ASCPUT(48,05,'YEARS')                                        FIN21000
c     ARR(1) = 45                                                       FIN21010
c     ARR(2) = 258                                                      FIN21020
c     ARR(3) = 1676                                                     FIN21030
c     ARR(4) = 30                                                       FIN21040
c     ARR(13) = 80                                                      FIN21050
c     ARR(5) = 40                                                       FIN21060
c     ARR(6) = 1000                                                     FIN21070
c     ARR(7) = 750                                                      FIN21080
c     ARR(8) = 0.006                                                    FIN21090
c     ARR(9) = 0.00015                                                  FIN21100
c     ARR(10) = 8500                                                    FIN21110
c     ARR(11) = 3000                                                    FIN21120
c     ARR(12) = 7                                                       FIN21130
c     DO 60 I = 1,12                                                    FIN21140
c     CALL RTC(ARR(I),1,5,0,STR(I))                                     FIN21150
c  60 CONTINUE                                                          FIN21160
c     CALL RTC(ARR(8),1,5,3,STR(8))                                     FIN21170
c     CALL RTC(ARR(9),1,7,5,STR(9))                                     FIN21180
c     DO 50 I = 1,12                                                    FIN21190
c*    CALL ASCPUT(24+I,7,STR(I))                                        FIN21200
c  50 CONTINUE                                                          FIN21210
c     CALL ASDFLD(151,31,50,1,21,2)                                     FIN21220
c  5  CALL ASDFLD(154,0,0,0,0,0)                                        FIN21230
c     CALL ASDFLD(152,0,0,0,0,0)                                        FIN21240
c     CALL ASDFLD(152,31,75,1,2,0)                                      FIN21250
c*    CALL ASCPUT(151,21,'ANY CHANGES,REPLY Y/N')                       FIN21260
c     CALL ASFCUR(152,1,1)                                              FIN21270
c*    CALL ASREAD(1.,0.,0.)                                             FIN21280
c     CALL ASCGET(152,1,ANS)                                            FIN21290
c     CALL ASDFLD(154,32,60,1,3,0)                                      FIN21300
c*    CALL ASCPUT(154,2,'   ')                                          FIN21310
c     IF (ANS.EQ.'Y') THEN                                              FIN21320
c     CALL ASDFLD(153,32,50,1,6,2)                                      FIN21330
c*    CALL ASCPUT(153,6,'ROW NO')                                       FIN21340
c     CALL ASFCUR(154,1,1)                                              FIN21350
c*    CALL ASREAD(1.0,0.,0.)                                            FIN21360
c     CALL ASCGET(154,2,ROW)                                            FIN21370
c     CALL CTR(ROW,1,ROW1,1)                                            FIN21380
c     IROW1 = ROW1                                                      FIN21390
c     CALL ASDFLD(24+IROW1,0,0,0,0,0)                                   FIN21400
c     CALL ASDFLD(24+IROW1,5+IROW1*2,39,1,07,0)                         FIN21410
c*    CALL ASCPUT(24+IROW1,7,'      ')                                  FIN21420
c     CALL ASFCUR(IROW1+24,1,1)                                         FIN21430
c*    CALL ASREAD(1.,0.,0.)                                             FIN21440
c     CALL ASCGET(IROW1+24,07,STR(IROW1))                               FIN21450
c*    CALL ASCPUT(IROW1+24,7,STR(IROW1))                                FIN21460
c     CALL CTR(STR(IROW1),1,ARR(IROW1),1)                               FIN21470
c     GOTO 5                                                            FIN21480
c     ENDIF                                                             FIN21490
c     CALL FSPCLR                                                       FIN21500
      RETURN                                                            FIN21510
      END                                                               FIN21520

C     THIS SUBROUTINE IS USED FOR INTERACTIVE DATA INPUT. IT SETS       FIN29060
C     UP THE APPROPRIATE SCREENS USING GDDM AND ALSO CHECKS TO SEE      FIN29070
C     THAT THE DATA IS SELF CONSISTENT.                                 FIN29080
c     SUBROUTINE INDA                                                   FIN29100
c     COMMON/INPUT/NH,NC,DELT,ARRAY1,ARRAY2                             FIN29110
c     COMMON/ALL/CPC,CPH,PIN,N,M,FLOWC,FLOWH,TPIH,
c    *   TPOH,TPIC,TPOC,FCH,FCC
c     COMMON/INP1/STRNH,STRNC
c     DIMENSION ARR(50,5),ARR2(50,5),ARRAY1(50,5),ARRAY2(50,5),STRNH(50)FIN29120
c     DIMENSION STRNC(50)
c     CHARACTER*5 ARR                                                   FIN29130
c     CHARACTER*5 DELT1                                                 FIN29140
c     CHARACTER*2 NH1                                                   FIN29150
c     CHARACTER*5 ARR2                                                  FIN29160
c     CHARACTER*2 NC1                                                   FIN29170
c     CHARACTER*2 ROW                                                   FIN29180
c     CHARACTER*2 COLUMN                                                FIN29190
c     CHARACTER * 1 REPLY                                               FIN29200
c     CHARACTER*12 STRNH,STRNC
c     K8 = 0                                                            FIN29210
c     CALL ASDFLD(11,2,2,1,41,2)                                        FIN29220
c     CALL GSCM(3)                                                      FIN29230
c     CALL GSCB(2.5,2.5)                                                FIN29240
c     CALL ASFCOL(11,2)                                                 FIN29250
c     CALL ASCPUT(11,41,'WELCOME TO HEN PACKAGE CREATED BY GROUP I')    FIN29260
c     CALL ASDFLD(1,8,2,1,27,2)                                         FIN29270
c     CALL GSCM(1)                                                      FIN29280
c     CALL ASCPUT(1,27,'ENTER NUMBER OF HOT STREAMS')                   FIN29290
c     CALL ASDFLD(2,12,2,1,28,2)                                        FIN29300
c     CALL ASCPUT(2,28,'ENTER NUMBER OF COLD STREAMS')                  FIN29310
c     CALL ASDFLD(20,16,2,1,30,2)                                       FIN29320
c     CALL ASCPUT(20,30,'ENTER MINIMUM TEMP. DIFFERENCE')               FIN29330
c     CALL ASDFLD(3,8,50,1,3,1)                                         FIN29340
c     CALL ASDFLD(4,12,50,1,3,1)                                        FIN29350
c     CALL ASCPUT(3,3,'   ')                                            FIN29360
c     CALL ASCPUT(4,3,'   ')                                            FIN29370
c     CALL ASFCUR(3,1,1)                                                FIN29380
c*    CALL ASREAD(1.0,0.0,0.0)                                          FIN29390
c     CALL ASCGET(3,2,NH1)                                              FIN29400
c     CALL ASFCUR(4,1,1)                                                FIN29410
c*    CALL ASREAD(1.0,0.0,0.0)                                          FIN29420
c     CALL ASCGET(4,2,NC1)                                              FIN29430
c     CALL ASDFLD(21,16,50,1,6,1)                                       FIN29440
c     CALL ASCPUT(21,6,'      ')                                        FIN29450
c     CALL ASFCUR(21,1,1)                                               FIN29460
c*    CALL ASREAD(1.0,0.0,0.0)                                          FIN29470
c     CALL ASCGET(21,5,DELT1)                                           FIN29480
c     CALL CTR(NH1,1,ZH,1)                                              FIN29490
c     CALL CTR(NC1,1,ZC,1)                                              FIN29500
c     CALL CTR(DELT1,1,DELT,1)                                          FIN29510
c     INH = ZH                                                          FIN29520
c     INC = ZC                                                          FIN29530
c     NH = INH                                                          FIN29540
c     NC = INC                                                          FIN29550
c     CALL ASDFLD(10,22,2,1,25,2)                                       FIN29560
c     CALL ASCPUT(10,25,'Un momento, por favor ...')                    FIN29570
c     CALL ASDFLD(12,24,2,1,38,2)                                       FIN29580
c     CALL ASCPUT(12,38,'PRESS ENTER TO ACHIEVE FASTER RESPONSE')       FIN29590
c*    CALL ASREAD(1.0,0.,0.)                                            FIN29600
c     CALL FSPCLR                                                       FIN29610
c                                                                       FIN29620
c                                                                       FIN29630
c                                                                       FIN29640
c     CALL ASDFLD(5*(NH+NC)+6,1,2,1,21,2)                               FIN29650
c     CALL ASCPUT(5*(NH+NC)+6,21,'ENTER HOT STREAM DATA')               FIN29660
c     CALL ASDFLD(5*NH+5*NC+1,3,2,1,7,2)                                FIN29670
c     CALL ASCPUT(5*(NH+NC)+1,7,'STR NO.')                              FIN29680
c     CALL ASDFLD(5*NH+5*NC+2,3,20,1,9,2)                               FIN29690
c     CALL ASCPUT(5*(NH+NC)+2,9,'FLOW RATE')                            FIN29700
c     CALL ASDFLD(5*NH+5*NC+3,3,35,1,13,2)                              FIN29710
c     CALL ASCPUT(5*(NH+NC)+3,13,'SPECIFIC HEAT')                       FIN29720
c     CALL ASDFLD(5*NH+5*NC+4,3,52,1,11,2)                              FIN29730
c     CALL ASCPUT(5*(NH+NC)+4,11,'INLET TEMP.')                         FIN29740
c     CALL ASDFLD(5*NH+5*NC+5,3,68,1,12,2)                              FIN29750
c     CALL ASCPUT(5*(NH+NC)+5,12,'OUTLET TEMP.')                        FIN29760
c     CALL ASDFLD(5*NH+5*NC+7,30,2,1,37,2)                              FIN29770
c     CALL ASCPUT(5*(NH+NC)+7,37,'PRESS ENTER TO CONTINUE ENTERING DATA'FIN29780
c    +)                                                                 FIN29790
c     DO 200 I = 1,6                                                    FIN29800
c     CALL ASFCOL(5*NH+5*NC+I,6)                                        FIN29810
c 200 CONTINUE                                                          FIN29820
c     CALL ASFCOL(5*NH+5*NC+7,2)                                        FIN29830
c     CALL GSWIN(0.,100.,0.,100.)                                       FIN29840
c     CALL GSCOL(1)                                                     FIN29850
c     CALL GSMOVE(0.,95.)                                               FIN29860
c     CALL GSLINE(100.,95.)                                             FIN29870
c     CALL GSMOVE(0.,90.)                                               FIN29880
c     CALL GSLINE(100.,90.)                                             FIN29890
c     CALL GSMOVE(20.,95.)                                              FIN29900
c     CALL GSLINE(20.,10.)                                              FIN29910
c     CALL GSMOVE(40.,95.)                                              FIN29920
c     CALL GSLINE(40.,10.)                                              FIN29930
c     CALL GSMOVE(60.,95.)                                              FIN29940
c     CALL GSLINE(60.,10.)                                              FIN29950
c     CALL GSMOVE(80.,95.)                                              FIN29960
c     CALL GSLINE(80.,10.)                                              FIN29970
c     CALL GSMOVE(0.0,10.)                                              FIN29980
c     CALL GSLINE(100.,10.)                                             FIN29990
c     K2 = 0                                                            FIN30000
c     DO 10 I = 1,5*NH,5                                                FIN30010
c     CALL ASDFLD(I,(I-4*K2)*2+4,5,1,6,1)                               FIN30020
c     CALL ASCPUT(I,6,'      ')                                         FIN30030
c     CALL ASDFLD(I+1,(I-4*K2)*2+4,21,1,6,1)                            FIN30040
c     CALL ASCPUT(I+1,6,'      ')                                       FIN30050
c     CALL ASDFLD(I+2,(I-4*K2)*2+4,37,1,6,1)                            FIN30060
c     CALL ASCPUT(I+2,6,'      ')                                       FIN30070
c     CALL ASDFLD(I+3,(I-4*K2)*2+4,53,1,6,1)                            FIN30080
c     CALL ASCPUT(I+3,6,'      ')                                       FIN30090
c     CALL ASDFLD(I+4,(I-4*K2)*2+4,69,1,6,1)                            FIN30100
c     CALL ASCPUT(I+4,6,'      ')                                       FIN30110
c     K2 = K2 + 1                                                       FIN30120
c  10 CONTINUE                                                          FIN30130
c     DO 120 I = 1,5*NH                                                 FIN30140
c     CALL ASFCOL(I,2)                                                  FIN30150
c     CALL ASFINT(I,1)                                                  FIN30160
c     CALL ASFHLT(I,2)                                                  FIN30170
c 120 CONTINUE                                                          FIN30180
c     J=0                                                               FIN30190
c     K=1                                                               FIN30200
c     DO 30 I = 1,5*NH                                                  FIN30210
c     IF (MOD(K,5).EQ.1) THEN                                           FIN30220
c     J = J + 1                                                         FIN30230
c     K = 1                                                             FIN30240
c     ENDIF                                                             FIN30250
c  32 CALL ASFCUR(I,1,1)                                                FIN30260
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN30270
c     CALL ASCGET(I,5,ARR(J,K))                                         FIN30280
c     CALL CTR(ARR(J,K),1,ARRAY1(J,K),1)                                FIN30290
c     IF (MOD(I,5).EQ.1) THEN                                           FIN30300
c     IF (ARRAY1(J,K).GT.ZH)THEN                                        FIN30310
c     CALL FSALRM                                                       FIN30320
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN30330
c     CALL ASDFLD(600,32,2,1,49,2)                                      FIN30340
c     CALL ASFHLT(600,1)                                                FIN30350
c     CALL ASCPUT(600,49,'ERROR - STR. NO. EXCEEDS TOTAL NO. OF HOT STREFIN30360
c    +AMS')                                                             FIN30370
c     GOTO 32                                                           FIN30380
c     ENDIF                                                             FIN30390
c     GOTO 36                                                           FIN30400
c     ENDIF                                                             FIN30410
c     IF (MOD(I,5).EQ.0) THEN                                           FIN30420
c     IF (ARRAY1(J,K).GE.ARRAY1(J,K-1)) THEN                            FIN30430
c     CALL FSALRM                                                       FIN30440
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN30450
c     CALL ASDFLD(600,32,2,1,60,2)                                      FIN30460
c     CALL ASFHLT(600,1)                                                FIN30470
c     CALL ASCPUT(600,60,'ERROR - OUTLET TEMPERATURE IS GREATER THAN INLFIN30480
c    +ET TEMPERATURE')                                                  FIN30490
c     GOTO 32                                                           FIN30500
c     ENDIF                                                             FIN30510
c     GOTO 36                                                           FIN30520
c     ENDIF                                                             FIN30530
c     IF (MOD(I,5).EQ.1.OR.MOD(I,5).EQ.2.OR. MOD(I,5).EQ.3) THEN        FIN30540
c     IF (ARRAY1(J,K) .LE.0) THEN                                       FIN30550
c     CALL FSALRM                                                       FIN30560
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN30570
c     CALL ASDFLD(600,32,2,1,30,2)                                      FIN30580
c     CALL ASFHLT(600,1)                                                FIN30590
c     CALL ASCPUT(600,30,'ERROR - VALUE MUST BE POSITIVE')              FIN30600
c     GOTO 32                                                           FIN30610
c     ENDIF                                                             FIN30620
c     ENDIF                                                             FIN30630
c  36 CALL ASDFLD(600,0,0,0,0,0)                                        FIN30640
c     IF (K8.EQ.1) THEN                                                 FIN30650
c     K8 = 0                                                            FIN30660
c     GOTO 92                                                           FIN30670
c     ENDIF                                                             FIN30680
c     K = K +1                                                          FIN30690
c  30 CONTINUE                                                          FIN30700
c  92 CALL ASDFLD(601,30,50,1,26,2)                                     FIN30710
c     CALL ASCPUT(601,26,'ANY MORE CHANGES,REPLY Y/N')                  FIN30720
c     CALL ASDFLD(602,0,0,0,0,0)                                        FIN30730
c     CALL ASDFLD(602,30,78,1,2,0)                                      FIN30740
c  91 CALL ASFCUR(602,1,1)                                              FIN30750
c*    CALL ASREAD(1.0,0.0,0.0)                                          FIN30760
c     CALL ASCGET(602,1,REPLY)                                          FIN30770
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN30780
c     IF (REPLY .EQ. 'Y') THEN                                          FIN30790
c     CALL ASDFLD(603,31,50,1,6,2)                                      FIN30800
c     CALL ASCPUT(603,6,'STR NO')                                       FIN30810
c     CALL ASDFLD(604,31,60,1,6,2)                                      FIN30820
c     CALL ASCPUT(604,26,'COL NO')                                      FIN30830
c     CALL ASDFLD(605,31,57,1,3,1)                                      FIN30840
c     CALL ASCPUT(605,2,'  ')                                           FIN30850
c     CALL ASDFLD(606,31,67,1,3,1)                                      FIN30860
c     CALL ASCPUT(606,2,'  ')                                           FIN30870
c  82 CALL ASFCUR(605,1,1)                                              FIN30880
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN30890
c     CALL ASCGET(605,2,ROW)                                            FIN30900
c     CALL CTR(ROW,1,ROW1,1)                                            FIN30910
c     IF (ROW1.GT.NH) THEN                                              FIN30920
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN30930
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN30940
c     CALL ASFHLT(600,1)                                                FIN30950
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN30960
c     GOTO 82                                                           FIN30970
c     ENDIF                                                             FIN30980
c  83 CALL ASFCUR(606,1,1)                                              FIN30990
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN31000
c     CALL ASCGET(606,2,COLUMN)                                         FIN31010
c     CALL CTR(COLUMN,1,COLUM1,1)                                       FIN31020
c     IF (COLUM1.GT.5) THEN                                             FIN31030
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN31040
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN31050
c     CALL ASFHLT(600,1)                                                FIN31060
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN31070
c     GOTO 83                                                           FIN31080
c     ENDIF                                                             FIN31090
c     CALL ASQCUR(0,FIDENT,ROW1,COLUM1)                                 FIN31100
c     J = ROW1                                                          FIN31110
c     K = COLUM1                                                        FIN31120
c     I = (J-1)*5 + K                                                   FIN31130
c     K8 = 1                                                            FIN31140
c     GOTO 32                                                           FIN31150
c     ENDIF                                                             FIN31160
c     IF (REPLY.NE.'Y' .AND. REPLY.NE.'N') THEN                         FIN31170
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN31180
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN31190
c     CALL ASFHLT(600,1)                                                FIN31200
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN31210
c     GOTO 91                                                           FIN31220
c     ENDIF                                                             FIN31230
c     DO 98 I = 1,NH                                                    FIN31240
c     DO 99 J = 1,5                                                     FIN31250
c     CALL CTR(ARR(I,J),1,ARRAY1(I,J),1)                                FIN31260
c  99 CONTINUE                                                          FIN31270
c  98 CONTINUE                                                          FIN31280
c  31 CALL FSPCLR                                                       FIN31290
c     K8 = 0                                                            FIN31300
c     CALL ASDFLD(5*(NH+NC)+6,1,2,1,22,2)                               FIN31310
c     CALL ASCPUT(5*(NH+NC)+6,22,'ENTER COLD STREAM DATA')              FIN31320
c     CALL ASDFLD(5*NH+5*NC+1,3,2,1,7,2)                                FIN31330
c     CALL ASCPUT(5*(NH+NC)+1,7,'STR NO.')                              FIN31340
c     CALL ASDFLD(5*NH+5*NC+2,3,20,1,9,2)                               FIN31350
c     CALL ASCPUT(5*(NH+NC)+2,9,'FLOW RATE')                            FIN31360
c     CALL ASDFLD(5*NH+5*NC+3,3,35,1,13,2)                              FIN31370
c     CALL ASCPUT(5*(NH+NC)+3,13,'SPECIFIC HEAT')                       FIN31380
c     CALL ASDFLD(5*NH+5*NC+4,3,52,1,11,2)                              FIN31390
c     CALL ASCPUT(5*(NH+NC)+4,11,'INLET TEMP.')                         FIN31400
c     CALL ASDFLD(5*NH+5*NC+5,3,68,1,12,2)                              FIN31410
c     CALL ASCPUT(5*(NH+NC)+5,12,'OUTLET TEMP.')                        FIN31420
c     CALL ASDFLD(5*NH+5*NC+7,30,2,1,37,2)                              FIN31430
c     CALL ASCPUT(5*(NH+NC)+7,37,'PRESS ENTER TO CONTINUE ENTERING DATA'FIN31440
c    +)                                                                 FIN31450
c     DO 100 I = 1,6                                                    FIN31460
c     CALL ASFCOL(5*NH+5*NC+I,6)                                        FIN31470
c 100 CONTINUE                                                          FIN31480
c     CALL ASFCOL(5*NH+5*NC+7,2)                                        FIN31490
c     CALL GSWIN(0.,100.,0.,100.)                                       FIN31500
c     CALL GSCOL(1)                                                     FIN31510
c     CALL GSMOVE(0.,95.)                                               FIN31520
c     CALL GSLINE(100.,95.)                                             FIN31530
c     CALL GSMOVE(0.,90.)                                               FIN31540
c     CALL GSLINE(100.,90.)                                             FIN31550
c     CALL GSMOVE(20.,95.)                                              FIN31560
c     CALL GSLINE(20.,10.)                                              FIN31570
c     CALL GSMOVE(40.,95.)                                              FIN31580
c     CALL GSLINE(40.,10.)                                              FIN31590
c     CALL GSMOVE(60.,95.)                                              FIN31600
c     CALL GSLINE(60.,10.)                                              FIN31610
c     CALL GSMOVE(80.,95.)                                              FIN31620
c     CALL GSLINE(80.,10.)                                              FIN31630
c     CALL GSMOVE(0.0,10.)                                              FIN31640
c     CALL GSLINE(100.,10.)                                             FIN31650
c     K2 = 0                                                            FIN31660
c     DO 60 I = 1,5*NC,5                                                FIN31670
c     CALL ASDFLD(I,(I-4*K2)*2+4,5,1,6,1)                               FIN31680
c     CALL ASCPUT(I,6,'      ')                                         FIN31690
c     CALL ASDFLD(I+1,(I-4*K2)*2+4,21,1,6,1)                            FIN31700
c     CALL ASCPUT(I+1,6,'      ')                                       FIN31710
c     CALL ASDFLD(I+2,(I-4*K2)*2+4,37,1,6,1)                            FIN31720
c     CALL ASCPUT(I+2,6,'      ')                                       FIN31730
c     CALL ASDFLD(I+3,(I-4*K2)*2+4,53,1,6,1)                            FIN31740
c     CALL ASCPUT(I+3,6,'      ')                                       FIN31750
c     CALL ASDFLD(I+4,(I-4*K2)*2+4,69,1,6,1)                            FIN31760
c     CALL ASCPUT(I+4,6,'      ')                                       FIN31770
c     K2 = K2 + 1                                                       FIN31780
c  60 CONTINUE                                                          FIN31790
c     DO 110 I = 1,5*NC                                                 FIN31800
c     CALL ASFCOL(I,5)                                                  FIN31810
c     CALL ASFINT(I,2)                                                  FIN31820
c     CALL ASFHLT(I,2)                                                  FIN31830
c 110 CONTINUE                                                          FIN31840
c     K=1                                                               FIN31850
c     J=0                                                               FIN31860
c     DO 50 I = 1,5*NC                                                  FIN31870
c     IF (MOD(K,5) .EQ. 1) THEN                                         FIN31880
c     J = J+1                                                           FIN31890
c     K = 1                                                             FIN31900
c     ENDIF                                                             FIN31910
c  33 CALL ASFCUR(I,1,1)                                                FIN31920
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN31930
c     CALL ASCGET(I,5,ARR2(J,K))                                        FIN31940
c     CALL CTR(ARR2(J,K),1,ARRAY2(J,K),1)                               FIN31950
c     IF (MOD(I,5).EQ.1) THEN                                           FIN31960
c     IF (ARRAY2(J,K).GT.ZC)THEN                                        FIN31970
c     CALL FSALRM                                                       FIN31980
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN31990
c     CALL ASDFLD(600,32,2,1,50,2)                                      FIN32000
c     CALL ASFHLT(600,1)                                                FIN32010
c     CALL ASCPUT(600,50,'ERROR - STR. NO. EXCEEDS TOTAL NO. OF COLD STRFIN32020
c    +EAMS')                                                            FIN32030
c     GOTO 33                                                           FIN32040
c     ENDIF                                                             FIN32050
c     GOTO 56                                                           FIN32060
c     ENDIF                                                             FIN32070
c     IF (MOD(I,5).EQ.0) THEN                                           FIN32080
c     IF (ARRAY2(J,K).LE.ARRAY2(J,K-1)) THEN                            FIN32090
c     CALL FSALRM                                                       FIN32100
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN32110
c     CALL ASDFLD(600,32,2,1,57,2)                                      FIN32120
c     CALL ASFHLT(600,1)                                                FIN32130
c     CALL ASCPUT(600,57,'ERROR - OUTLET TEMPERATURE IS LESS THAN INLET FIN32140
c    +TEMPERATURE')                                                     FIN32150
c     GOTO 33                                                           FIN32160
c     ENDIF                                                             FIN32170
c     GOTO 56                                                           FIN32180
c     ENDIF                                                             FIN32190
c     IF (MOD(I,5).EQ.1.OR.MOD(I,5).EQ.2.OR. MOD(I,5).EQ.3) THEN        FIN32200
c     IF (ARRAY2(J,K).LE.0) THEN                                        FIN32210
c     CALL FSALRM                                                       FIN32220
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN32230
c     CALL ASDFLD(600,32,2,1,30,2)                                      FIN32240
c     CALL ASFHLT(600,1)                                                FIN32250
c     CALL ASCPUT(600,30,'ERROR - VALUE MUST BE POSITIVE')              FIN32260
c     GOTO 33                                                           FIN32270
c     ENDIF                                                             FIN32280
c     ENDIF                                                             FIN32290
c  56 CALL ASDFLD(600,0,0,0,0,0)                                        FIN32300
c     IF (K8.EQ.1) THEN                                                 FIN32310
c     K8 = 0                                                            FIN32320
c     GOTO 72                                                           FIN32330
c     ENDIF                                                             FIN32340
c     K = K+1                                                           FIN32350
c  50 CONTINUE                                                          FIN32360
c  72 CALL ASDFLD(601,30,50,1,26,2)                                     FIN32370
c     CALL ASCPUT(601,26,'ANY MORE CHANGES,REPLY Y/N')                  FIN32380
c     CALL ASDFLD(602,0,0,0,0,0)                                        FIN32390
c     CALL ASDFLD(602,30,78,1,2,0)                                      FIN32400
c  71 CALL ASFCUR(602,1,1)                                              FIN32410
c*    CALL ASREAD(1.0,0.0,0.0)                                          FIN32420
c     CALL ASCGET(602,1,REPLY)                                          FIN32430
c     IF (REPLY .EQ. 'Y') THEN                                          FIN32440
c     CALL ASDFLD(603,31,50,1,6,2)                                      FIN32450
c     CALL ASCPUT(603,6,'STR NO')                                       FIN32460
c     CALL ASDFLD(604,31,60,1,6,2)                                      FIN32470
c     CALL ASCPUT(604,26,'COL NO')                                      FIN32480
c     CALL ASDFLD(605,31,57,1,3,1)                                      FIN32490
c     CALL ASCPUT(605,2,'  ')                                           FIN32500
c     CALL ASDFLD(606,31,67,1,3,1)                                      FIN32510
c     CALL ASCPUT(606,2,'  ')                                           FIN32520
c  84 CALL ASFCUR(605,1,1)                                              FIN32530
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN32540
c     CALL ASCGET(605,2,ROW)                                            FIN32550
c     CALL CTR(ROW,1,ROW1,1)                                            FIN32560
c     IF (ROW1.GT.NC) THEN                                              FIN32570
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN32580
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN32590
c     CALL ASFHLT(600,1)                                                FIN32600
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN32610
c     GOTO 84                                                           FIN32620
c     ENDIF                                                             FIN32630
c  85 CALL ASFCUR(606,1,1)                                              FIN32640
c*    CALL ASREAD(1.0,0.0,0.)                                           FIN32650
c     CALL ASCGET(606,2,COLUMN)                                         FIN32660
c     CALL CTR(COLUMN,1,COLUM1,1)                                       FIN32670
c     IF (COLUM1.GT.5) THEN                                             FIN32680
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN32690
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN32700
c     CALL ASFHLT(600,1)                                                FIN32710
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN32720
c     GOTO 85                                                           FIN32730
c     ENDIF                                                             FIN32740
c     J = ROW1                                                          FIN32750
c     K = COLUM1                                                        FIN32760
c     I = (J-1)*5 + K                                                   FIN32770
c     K8 = 1                                                            FIN32780
c     GOTO 33                                                           FIN32790
c     ENDIF                                                             FIN32800
c     IF (REPLY.NE.'Y' .AND. REPLY.NE.'N') THEN                         FIN32810
c     CALL ASDFLD(600,0,0,0,0,0)                                        FIN32820
c     CALL ASDFLD(600,32,2,1,23,2)                                      FIN32830
c     CALL ASFHLT(600,1)                                                FIN32840
c     CALL ASCPUT(600,23,'ERROR - INCORRECT REPLY')                     FIN32850
c     GOTO 71                                                           FIN32860
c     ENDIF                                                             FIN32870
c     DO 96 I = 1,NC                                                    FIN32880
c     DO 97 J = 1,5                                                     FIN32890
c     CALL CTR(ARR2(I,J),1,ARRAY2(I,J),1)                               FIN32900
c  97 CONTINUE                                                          FIN32910
c  96 CONTINUE                                                          FIN32920
c     CALL FSPCLR                                                       FIN32930
c     RETURN                                                            FIN32940
c     END                                                               FIN32950
c     THIS SUBROUTINE PRESENTS THE FIRST SCREEN TO THE USER AND QUERIES FIN32980
c     HIM/HER ON THE OPTIONS HE/SHE WANTS. WHICH SUBROUTINES ARE        FIN32990
c     EXECUTED IS DETERMINED BY THE OPTIONS SPECIFIED HERE.             FIN33000
c     SUBROUTINE INFIR                                                  FIN33020
c     CHARACTER*1 STR1                                                  FIN33030
c     CHARACTER*1 STR2                                                  FIN33040
c     CHARACTER*1 STR3                                                  FIN33050
c     COMMON/LAB1/KJ1,KJ2,KJ3                                           FIN33060
c     CALL FSINIT                                                       FIN33070
c     CALL ASDFLD(1,4,28,1,22,2)                                        FIN33080
c     CALL ASCPUT(1,22,'HEAT EXCHANGER NETWORK')                        FIN33090
c     CALL ASCCOL(1,22,'1235612356123561235612')                        FIN33100
c     CALL ASDFLD(50,5,28,1,22,2)                                       FIN33110
c     CALL ASFCOL(50,5)                                                 FIN33120
c     CALL ASCPUT(50,22,'======================')                       FIN33130
c     CALL ASDFLD(2,8,2,1,67,2)                                         FIN33140
c     CALL ASFCOL(2,1)                                                  FIN33150
c     CALL ASCPUT(2,67,'DO YOU WANT TO ENTER DATA INTERACTIVELY OR READ FIN33160
cc   +IT FROM A DATA FILE')                                             FIN33170
cc    CALL ASDFLD(3,10,2,1,36,2)                                        FIN33180
c     CALL ASFCOL(3,2)                                                  FIN33190
c     CALL ASCPUT(3,36,'REPLY I/D(I-INTERACTIVE,D-DATA FILE)')          FIN33200
c     CALL ASDFLD(4,14,2,1,44,2)                                        FIN33210
c     CALL ASFCOL(4,1)                                                  FIN33220
c     CALL ASCPUT(4,44,'DO YOU WANT THE COST ESTIMATE OF THE NETWORK')  FIN33230
c     CALL ASDFLD(5,16,2,1,9,2)                                         FIN33240
c     CALL ASFCOL(5,2)                                                  FIN33250
c     CALL ASCPUT(5,9,'REPLY Y/N')                                      FIN33260
c     CALL ASDFLD(10,10,50,1,2,0)                                       FIN33270
c     CALL ASCPUT(10,2,'  ')                                            FIN33280
c     CALL ASFCUR(10,1,1)                                               FIN33290
c*    CALL ASREAD(1.,0.,0.)                                             FIN33300
c     CALL ASCGET(10,1,STR1)                                            FIN33310
c     CALL ASDFLD(11,16,50,1,2,0)                                       FIN33320
c     CALL ASCPUT(11,2,'  ')                                            FIN33330
c     CALL ASFCUR(11,1,1)                                               FIN33340
c*    CALL ASREAD(1.,0.,0.)                                             FIN33350
c     CALL ASCGET(11,1,STR2)                                            FIN33360
c     IF (STR1.EQ.'I') KJ1 = 1                                          FIN33370
c     IF (STR1.EQ.'D') KJ1 = 2                                          FIN33380
c     IF (STR2.EQ.'Y') KJ2 = 1                                          FIN33390
c     IF (STR2.EQ.'N') KJ2 = 2                                          FIN33400
c     CALL ASDFLD(19,21,5,1,22,2)                                       FIN33410
c     CALL ASFCOL(19,6)                                                 FIN33420
c     CALL ASCPUT(19,22,'UNITS TO BE USED ARE :')                       FIN33430
c     DO 20 I = 1,3                                                     FIN33440
c     CALL ASDFLD(21 + I,21+I,10,1,27,2)                                FIN33450
c     CALL ASFCOL(21+I,5)                                               FIN33460
c 20  CONTINUE                                                          FIN33470
c     CALL ASCPUT(22,27,'FLOW RATES    - KG/HR      ')                  FIN33480
c     CALL ASCPUT(23,27,'SPECIFIC HEAT - KJ/KG/DEG K')                  FIN33490
c     CALL ASCPUT(24,27,'TEMPERATURE   - DEG C      ')                  FIN33500
c     CALL ASDFLD(30,28,2,1,36,2)                                       FIN33510
c     CALL ASFCOL(30,2)                                                 FIN33520
c     CALL ASCPUT(30,36,'ARE THE UNITS USED CORRECT,REPLY Y/N')         FIN33530
c     CALL ASDFLD(31,28,50,1,2,0)                                       FIN33540
c     CALL ASCPUT(31,2,'  ')                                            FIN33550
c     CALL ASFCUR(31,1,1)                                               FIN33560
c*    CALL ASREAD(1.,0.,0.)                                             FIN33570
c     CALL ASCGET(31,1,STR3)                                            FIN33580
c     IF (STR3 .EQ. 'Y') KJ3 = 1                                        FIN33590
c     IF (STR3 .EQ. 'N') KJ3 = 2                                        FIN33600
c     CALL FSPCLR                                                       FIN33610
c     CALL FSTERM                                                       FIN33620
c     RETURN                                                            FIN33630
c     END                                                               FIN33640
C     THIS SUBROUTINE DETECTS LOOPS PRESENT IN THE NETWORK.             FIN33670
      SUBROUTINE LOOP (NH,NC,HEX,NHEN,HEXB,NHENB)                       FIN33690
      IMPLICIT INTEGER (A-Z)                                            FIN33700
      REAL HEXB,HEX                                                     FIN33710
      DIMENSION ROW(100),A(100,150),COL(150),LAB(100),POOL(150,150)     FIN33720
     * ,HEXB(50,11),HEX(50,11)                                          FIN33730
      DO 1001 I=1,100                                                   FIN33740
      LAB(I)=I                                                          FIN33750
1001  CONTINUE                                                          FIN33760
C     READ(5,*)N,M                                                      FIN33770
C     DO 1 II=1,N                                                       FIN33780
C     READ(5,*)(A(II,JK),JK=1,M)                                        FIN33790
C1    CONTINUE                                                          FIN33800
      N=NH+NC                                                           FIN33810
      M=NHEN+NHENB                                                      FIN33820
      DO 10 I=1,NHEN                                                    FIN33830
      A((HEX(I,3)),I)=1                                                 FIN33840
      A((HEX(I,2)+NH),I)=-1                                             FIN33850
 10   CONTINUE                                                          FIN33860
      DO 9 I=1,NHENB                                                    FIN33870
      A((HEXB(I,3)),I+NHEN)=1                                           FIN33880
      A((HEXB(I,2)+NH),I+NHEN)=-1                                       FIN33890
 9    CONTINUE                                                          FIN33900
C     DO 30 I=1,N                                                       FIN33910
C     WRITE(6,200) (A(I,J),J=1,M)                                       FIN33920
C30   CONTINUE                                                          FIN33930
C CHECKING WHETHER ALL THE ELEMENTS OF A ROW ARE ZERO                   FIN33950
      LSC=M                                                             FIN33960
      LST=N                                                             FIN33970
      DO 11 I=1,N-1                                                     FIN33980
C CHECK WHETHER THE ROW HAS ANY NON ZERO ELENMENTS;                     FIN34000
C IF SO DO ROW REDUCTIONS                                               FIN34010
      DO 52 IC=1,M                                                      FIN34030
      IF(ABS(A(I,IC)).GT.0) THEN                                        FIN34040
C  ROW REDUCTIONS:                                                      FIN34050
C INITIALIZE MAX TO ZERO                                                FIN34060
152      COL(I)=0                                                       FIN34070
         MAX=0                                                          FIN34080
C FOR COL I FIND ROW WITH LARGEST ELEMENT                               FIN34100
         DO 15 J=1,M                                                    FIN34120
         IF(ABS(A(I,J)).GT.MAX) THEN                                    FIN34130
           COL(I)=J                                                     FIN34140
           MAX=ABS(A(I,J))                                              FIN34150
         ENDIF                                                          FIN34160
15       CONTINUE                                                       FIN34170
C CHECK IF LARGEST ELEMENT IS ON THE DIAGANOL OR NOT                    FIN34180
         IF(COL(I).NE.I) THEN                                           FIN34190
           IF (MAX.GT.0) THEN                                           FIN34200
C IF IT IS NOT EXCHANGE THE TWO ROWS                                    FIN34210
               K=COL(I)                                                 FIN34220
               TEMP1=LAB(I)                                             FIN34230
               LAB(I)=LAB(K)                                            FIN34240
               LAB(K)=TEMP1                                             FIN34250
               DO 13 L=1,N                                              FIN34260
               TEMP=A(L,I)                                              FIN34270
               A(L,I)=A(L,K)                                            FIN34280
               A(L,K)=TEMP                                              FIN34290
13             CONTINUE                                                 FIN34300
             ENDIF                                                      FIN34310
           ENDIF                                                        FIN34320
C  NORMALISE THE ROW                                                    FIN34330
           IF(A(I,I).NE.0) THEN                                         FIN34340
             TEMP=A(I,I)                                                FIN34350
             DO 16 L=1,M                                                FIN34360
             A(L,I)=A(L,I)/TEMP                                         FIN34370
16           CONTINUE                                                   FIN34380
C MAKE ALL ELEMENTS OF THAT COL ZERO EXCEPT THE DIAGANOL                FIN34390
             DO 144 L=1,N                                               FIN34400
             IF(I.EQ.L) GOTO 144                                        FIN34410
             IFAC=A(L,I)/A(I,I)                                         FIN34420
             DO 14 L1=1,M                                               FIN34430
             A(L,L1)=A(L,L1)-IFAC*A(I,L1)                               FIN34440
14           CONTINUE                                                   FIN34450
144          CONTINUE 
           ENDIF                                                        FIN34460
           GO TO 11                                                     FIN34470
C  END ROW REDUCTIONS                                                   FIN34480
      ELSE                                                              FIN34490
C IF IC LESS THAN # OF HEAT EXCHANGERS, CONTINUE                        FIN34500
           IF(IC.EQ.M) THEN                                             FIN34510
             IF(LST.GE.I) THEN                                          FIN34520
C  INTERCHANGING ROWS                                                   FIN34530
               DO 51 II=1,M                                             FIN34540
               TSTOR=A(I,II)                                            FIN34550
               A(I,II)=A(LST,II)                                        FIN34560
               A(LST,II)=TSTOR                                          FIN34570
51             CONTINUE                                                 FIN34580
               LST=LST-1                                                FIN34590
               GO TO 152                                                FIN34600
             ELSE                                                       FIN34610
               GO TO 29                                                 FIN34620
             ENDIF                                                      FIN34630
           ENDIF                                                        FIN34640
      ENDIF                                                             FIN34650
52    CONTINUE                                                          FIN34660
11    CONTINUE                                                          FIN34670
29    CONTINUE                                                          FIN34680
C29   WRITE(6,*)'======================================='               FIN34690
C     WRITE(6,101)(LAB(II),II=1,M)                                      FIN34700
C     WRITE(6,*)'======================================='               FIN34710
      DO 100 I=1,N                                                      FIN34720
C     WRITE(6,101) (A(I,J),J=1,M)                                       FIN34730
101   FORMAT(3X,30I3)                                                   FIN34740
100   CONTINUE                                                          FIN34750
C  CHECKING THE RANK OF THE LOOP MATRIX                                 FIN34760
      DO 20 I=1,N                                                       FIN34770
      IF(A(I,I).EQ.0) THEN                                              FIN34780
      RANK=I-1                                                          FIN34790
      GO TO 21                                                          FIN34800
      ENDIF                                                             FIN34810
20    CONTINUE                                                          FIN34820
C   IDENTIFYING THE HEAT EXCHANGERS INVOLVED IN LOOPS                   FIN34830
21    LO=0                                                              FIN34840
      DO 220 I=RANK+1,M                                                 FIN34850
      CT=0                                                              FIN34860
      ICODE=0                                                           FIN34870
      DO 22 IJ=1,N                                                      FIN34880
      IF(A(IJ,I).NE.0) THEN                                             FIN34890
        ICODE=1                                                         FIN34900
        CT=CT+1                                                         FIN34910
        POOL(I-RANK,1)=CT+3                                             FIN34920
        POOL(I-RANK,3)=LAB(I)                                           FIN34930
        POOL(I-RANK,CT+3)=LAB(IJ)                                       FIN34940
      ENDIF                                                             FIN34950
22    CONTINUE                                                          FIN34960
      IF(ICODE.EQ.1) THEN                                               FIN34970
        LO=LO+1                                                         FIN34980
        POOL(I-RANK,2)=LO                                               FIN34990
      ENDIF                                                             FIN35000
220   CONTINUE                                                          FIN35010
      IF(RANK.LT.M) THEN                                                FIN35020
      WRITE(6,*)                                                        FIN35030
      WRITE(6,*)'======================================================'FIN35040
      WRITE(6,*)'LOOP#                  HEAT EXCHANGERS INVOLVED'       FIN35050
      WRITE(6,*)'======================================================'FIN35060
      DO 23 I=1,M-RANK                                                  FIN35070
      CT=POOL(I,1)                                                      FIN35080
      iflag1 = 1
      icount = 0
      do 9999 j = 3,ct
      if (pool(i,j).ne.pool(i,3)) iflag1 = 0
9999  continue
      IF(CT.GT.0 .and. iflag1.eq.0) THEN
        WRITE(6,200)(POOL(I,J),J=2,CT)
      ENDIF                                                             FIN35110
23    CONTINUE                                                          FIN35120
      ELSE                                                              FIN35130
      WRITE(6,*)'NO LOOPS PRESENT IN THIS NETWORK'                      FIN35140
      ENDIF                                                             FIN35150
      WRITE(6,*)'======================================================'FIN35160
200   FORMAT(I3,10X,150I3)                                              FIN35170
      RETURN                                                            FIN35180
      END                                                               FIN35190
C     THIS SUBROUTINE SORTS VECTORS WITH 3 ATTRIBUTES ON TWO ATTRIBUTES FIN35220
C     AND ARRANGES THEM IN DECREASING ORDER IN THE FIRST AND WITHIN THATFIN35230
C     DECREASING ORDER IN THE SECOND.                                   FIN35240
      SUBROUTINE DD (NO,AUX)                                            FIN35260
      DIMENSION AUX(3,NO)                                               FIN35270
      DO 12 J=2,NO                                                      FIN35280
      A=AUX(1,J)                                                        FIN35290
      B=AUX(2,J)                                                        FIN35300
      C=AUX(3,J)                                                        FIN35310
      DO 11 I=J-1,1,-1                                                  FIN35320
      IF(AUX(1,I).GE.A) GO TO 10                                        FIN35330
      AUX(1,(I+1))=AUX(1,I)                                             FIN35340
      AUX(2,(I+1))=AUX(2,I)                                             FIN35350
      AUX(3,(I+1))=AUX(3,I)                                             FIN35360
11    CONTINUE                                                          FIN35370
10    AUX(1,(I+1))=A                                                    FIN35380
      AUX(2,(I+1))=B                                                    FIN35390
      AUX(3,(I+1))=C                                                    FIN35400
12    CONTINUE                                                          FIN35410
      DO 15 I=1,NO-1                                                    FIN35420
      DO 14 J=I+1,NO                                                    FIN35430
      A=AUX(1,I)                                                        FIN35440
      B=AUX(2,I)                                                        FIN35450
      C=AUX(3,I)                                                        FIN35460
      DIFF=ABS(A-AUX(1,J))                                              FIN35470
      IF((DIFF.LE.0.0001).AND.(AUX(3,J).GE.C)) THEN                     FIN35480
      AUX(1,I)=AUX(1,J)                                                 FIN35490
      AUX(2,I)=AUX(2,J)                                                 FIN35500
      AUX(3,I)=AUX(3,J)                                                 FIN35510
      AUX(1,J)=A                                                        FIN35520
      AUX(2,J)=B                                                        FIN35530
      AUX(3,J)=C                                                        FIN35540
      ENDIF                                                             FIN35550
14    CONTINUE                                                          FIN35560
15    CONTINUE                                                          FIN35570
      RETURN                                                            FIN35580
      END                                                               FIN35590
C     THIS SUBROUTINE SORTS VECTORS WITH 3 ATTRIBUTES ON TWO ATTRIBUTES FIN35620
C     AND ARRANGES THEM IN DECREASING ORDER IN THE FIRST AND WITHIN THATFIN35630
C     INCREASING ORDER IN THE SECOND.                                   FIN35640
      SUBROUTINE DI (NO,AUX)                                            FIN35660
      DIMENSION AUX(3,NO)                                               FIN35670
      DO 12 J=2,NO                                                      FIN35680
      A=AUX(1,J)                                                        FIN35690
      B=AUX(2,J)                                                        FIN35700
      C=AUX(3,J)                                                        FIN35710
      DO 11 I=J-1,1,-1                                                  FIN35720
      IF(AUX(1,I).GE.A) GO TO 10                                        FIN35730
      AUX(1,(I+1))=AUX(1,I)                                             FIN35740
      AUX(2,(I+1))=AUX(2,I)                                             FIN35750
      AUX(3,(I+1))=AUX(3,I)                                             FIN35760
11    CONTINUE                                                          FIN35770
10    AUX(1,(I+1))=A                                                    FIN35780
      AUX(2,(I+1))=B                                                    FIN35790
      AUX(3,(I+1))=C                                                    FIN35800
12    CONTINUE                                                          FIN35810
      DO 15 I=1,NO-1                                                    FIN35820
      DO 14 J=I+1,NO                                                    FIN35830
      A=AUX(1,I)                                                        FIN35840
      B=AUX(2,I)                                                        FIN35850
      C=AUX(3,I)                                                        FIN35860
      DIFF=ABS(A-AUX(1,J))                                              FIN35870
      IF((DIFF.LE.0.0001).AND.(AUX(3,J).LE.C)) THEN                     FIN35880
      AUX(1,I)=AUX(1,J)                                                 FIN35890
      AUX(2,I)=AUX(2,J)                                                 FIN35900
      AUX(3,I)=AUX(3,J)                                                 FIN35910
      AUX(1,J)=A                                                        FIN35920
      AUX(2,J)=B                                                        FIN35930
      AUX(3,J)=C                                                        FIN35940
      ENDIF                                                             FIN35950
14    CONTINUE                                                          FIN35960
15    CONTINUE                                                          FIN35970
      RETURN                                                            FIN35980
      END                                                               FIN35990
C     THIS SUBROUTINE SORTS VECTORS WITH 3 ATTRIBUTES ON TWO ATTRIBUTES FIN36020
C     AND ARRANGES THEM IN INCREASING ORDER IN THE FIRST AND WITHIN THATFIN36030
C     DECREASING ORDER IN THE SECOND.                                   FIN36040
      SUBROUTINE ID (NO,AUX)                                            FIN36060
      DIMENSION AUX(3,NO)                                               FIN36070
      DO 12 J=2,NO                                                      FIN36080
      A=AUX(1,J)                                                        FIN36090
      B=AUX(2,J)                                                        FIN36100
      C=AUX(3,J)                                                        FIN36110
      DO 11 I=J-1,1,-1                                                  FIN36120
      IF(AUX(1,I).LE.A) GO TO 10                                        FIN36130
      AUX(1,(I+1))=AUX(1,I)                                             FIN36140
      AUX(2,(I+1))=AUX(2,I)                                             FIN36150
      AUX(3,(I+1))=AUX(3,I)                                             FIN36160
11    CONTINUE                                                          FIN36170
10    AUX(1,(I+1))=A                                                    FIN36180
      AUX(2,(I+1))=B                                                    FIN36190
      AUX(3,(I+1))=C                                                    FIN36200
12    CONTINUE                                                          FIN36210
      DO 15 I=1,NO-1                                                    FIN36220
      DO 14 J=I+1,NO                                                    FIN36230
      A=AUX(1,I)                                                        FIN36240
      B=AUX(2,I)                                                        FIN36250
      C=AUX(3,I)                                                        FIN36260
      DIFF=ABS(A-AUX(1,J))                                              FIN36270
      IF((DIFF.LE.0.0001).AND.(AUX(3,J).GE.C)) THEN                     FIN36280
      AUX(1,I)=AUX(1,J)                                                 FIN36290
      AUX(2,I)=AUX(2,J)                                                 FIN36300
      AUX(3,I)=AUX(3,J)                                                 FIN36310
      AUX(1,J)=A                                                        FIN36320
      AUX(2,J)=B                                                        FIN36330
      AUX(3,J)=C                                                        FIN36340
      ENDIF                                                             FIN36350
14    CONTINUE                                                          FIN36360
15    CONTINUE                                                          FIN36370
      RETURN                                                            FIN36380
      END                                                               FIN36390
C     THIS SUBROUTINE SORTS VECTORS WITH 3 ATTRIBUTES ON TWO ATTRIBUTES FIN36420
C     AND ARRANGES THEM IN INCREASING ORDER IN THE FIRST AND WITHIN THATFIN36430
C     INCREASING ORDER IN THE SECOND.                                   FIN36440
      SUBROUTINE II (NO,AUX)                                            FIN36460
      DIMENSION AUX(3,NO)                                               FIN36470
      DO 12 J=2,NO                                                      FIN36480
      A=AUX(1,J)                                                        FIN36490
      B=AUX(2,J)                                                        FIN36500
      C=AUX(3,J)                                                        FIN36510
      DO 11 I=J-1,1,-1                                                  FIN36520
      IF(AUX(1,I).LE.A) GO TO 10                                        FIN36530
      AUX(1,(I+1))=AUX(1,I)                                             FIN36540
      AUX(2,(I+1))=AUX(2,I)                                             FIN36550
      AUX(3,(I+1))=AUX(3,I)                                             FIN36560
11    CONTINUE                                                          FIN36570
10    AUX(1,(I+1))=A                                                    FIN36580
      AUX(2,(I+1))=B                                                    FIN36590
      AUX(3,(I+1))=C                                                    FIN36600
12    CONTINUE                                                          FIN36610
      DO 15 I=1,NO-1                                                    FIN36620
      DO 14 J=I+1,NO                                                    FIN36630
      A=AUX(1,I)                                                        FIN36640
      B=AUX(2,I)                                                        FIN36650
      C=AUX(3,I)                                                        FIN36660
      DIFF=ABS(A-AUX(1,J))                                              FIN36670
      IF((DIFF.LE.0.0001).AND.(AUX(3,J).LE.C)) THEN                     FIN36680
      AUX(1,I)=AUX(1,J)                                                 FIN36690
      AUX(2,I)=AUX(2,J)                                                 FIN36700
      AUX(3,I)=AUX(3,J)                                                 FIN36710
      AUX(1,J)=A                                                        FIN36720
      AUX(2,J)=B                                                        FIN36730
      AUX(3,J)=C                                                        FIN36740
      ENDIF                                                             FIN36750
14    CONTINUE                                                          FIN36760
15    CONTINUE                                                          FIN36770
      RETURN                                                            FIN36780
      END                                                               FIN36790
C     THIS SUBROUTINE SORTS VECTORS WITH THREE ATTRIBUTES IN DECREASING FIN36820
C     ORDER OF ONE ATTRIBUTE.                                           FIN36830
      SUBROUTINE PDKSRT(NO,AUX)                                         FIN36850
      DIMENSION AUX(3,NO)                                               FIN36860
      DO 12 J=2,NO                                                      FIN36870
      A=AUX(1,J)                                                        FIN36880
      B=AUX(2,J)                                                        FIN36890
      C=AUX(3,J)                                                        FIN36900
      DO 11 I=J-1,1,-1                                                  FIN36910
      IF(AUX(1,I).GE.A) GO TO 10                                        FIN36920
      AUX(1,(I+1))=AUX(1,I)                                             FIN36930
      AUX(2,(I+1))=AUX(2,I)                                             FIN36940
      AUX(3,(I+1))=AUX(3,J)                                             FIN36950
11    CONTINUE                                                          FIN36960
10    AUX(1,(I+1))=A                                                    FIN36970
      AUX(2,(I+1))=B                                                    FIN36980
      AUX(3,(I+1))=C                                                    FIN36990
12    CONTINUE                                                          FIN37000
      RETURN                                                            FIN37010
      END                                                               FIN37020
C     THIS SUBROUTINE SORTS VECTORS WITH THREE ATTRIBUTES IN INCREASING FIN37050
C     ORDER OF ONE ATTRIBUTE.                                           FIN37060
      SUBROUTINE PIKSRT(NO,AUX)                                         FIN37080
      DIMENSION AUX(2,NO)                                               FIN37090
      DO 12 J=2,NO                                                      FIN37100
      A=AUX(1,J)                                                        FIN37110
      B=AUX(2,J)                                                        FIN37120
      DO 11 I=J-1,1,-1                                                  FIN37130
      IF(AUX(1,I).LE.A) GO TO 10                                        FIN37140
      AUX(1,(I+1))=AUX(1,I)                                             FIN37150
      AUX(2,(I+1))=AUX(2,I)                                             FIN37160
11    CONTINUE                                                          FIN37170
10    AUX(1,(I+1))=A                                                    FIN37180
      AUX(2,(I+1))=B                                                    FIN37190
12    CONTINUE                                                          FIN37200
      RETURN                                                            FIN37210
      END                                                               FIN37220
C     THIS SUBROUTINE SEEMS TO DUPLICATE SUBROUTINE ID                  FIN37250
      SUBROUTINE PIDSRT(NO,AUX)                                         FIN37270
      DIMENSION AUX(3,NO)                                               FIN37280
      DO 12 J=2,NO                                                      FIN37290
      A=AUX(1,J)                                                        FIN37300
      B=AUX(2,J)                                                        FIN37310
      C=AUX(3,J)                                                        FIN37320
      DO 11 I=J-1,1,-1                                                  FIN37330
      IF(AUX(1,I).LT.A) GO TO 11                                        FIN37340
      IF((AUX(1,I).GT.A).OR.((AUX(1,I).EQ.A).AND.(AUX(3,I).LE.C))) THEN FIN37350
        AUX(1,(I+1))=AUX(1,I)                                           FIN37360
        AUX(2,(I+1))=AUX(2,I)                                           FIN37370
        AUX(3,(I+1))=AUX(3,I)                                           FIN37380
      AUX(1,I)=A                                                        FIN37390
      AUX(2,I)=B                                                        FIN37400
      AUX(3,I)=C                                                        FIN37410
      ENDIF                                                             FIN37420
11    CONTINUE                                                          FIN37430
12    CONTINUE                                                          FIN37440
      RETURN                                                            FIN37450
      END                                                               FIN37460
C     THIS SUBROUTINE SEEMS TO DUPLICATE SUBROUTINE II                  FIN37490
      SUBROUTINE PIISRT(NO,AUX)                                         FIN37510
      DIMENSION AUX(3,NO)                                               FIN37520
      DO 12 J=2,NO                                                      FIN37530
      A=AUX(1,J)                                                        FIN37540
      B=AUX(2,J)                                                        FIN37550
      C=AUX(3,J)                                                        FIN37560
      DO 11 I=J-1,1,-1                                                  FIN37570
      IF(AUX(1,I).GT.A) GO TO 11                                        FIN37580
      IF((AUX(1,I).LT.A).OR.((AUX(1,I).EQ.A).AND.(AUX(3,I).GE.C))) THEN FIN37590
        AUX(1,(I+1))=AUX(1,I)                                           FIN37600
        AUX(2,(I+1))=AUX(2,I)                                           FIN37610
        AUX(3,(I+1))=AUX(3,I)                                           FIN37620
      AUX(1,I)=A                                                        FIN37630
      AUX(2,I)=B                                                        FIN37640
      AUX(3,I)=C                                                        FIN37650
      ENDIF                                                             FIN37660
11    CONTINUE                                                          FIN37670
12    CONTINUE                                                          FIN37680
      RETURN                                                            FIN37690
      END                                                               FIN37700

