       subroutine gcc1(n,heat,temp)
       dimension q(100,2),str(100,2),q1(100,2),temp(100),heat(100)
       character*5 str
       character*1 ch
       character*17 pinch
       character*1 pnch(17),gcc(21),ht(9),tmp(11)
       character*21 gccur
       character*9 heat1
       character*11 temp1
       gccur = 'GRAND COMPOSITE CURVE'
       pinch = 'PINCH TEMPERATURE'
       heat1 = 'HEAT LOAD'
       temp1 = 'TEMPERATURE'
       call sglttr(pinch,17,pnch)
       call sglttr(gccur,21,gcc)
       call sglttr(heat1,9,ht)
       call sglttr(temp1,11,tmp)
       do 11 i=1,n
       q(i,1) = heat(n+1-i)
       q(i,2) = temp(n+1-i)
11     continue
       qmax = q(1,1)
       do 20 i = 2,n
       if (q(i,1).gt.qmax) qmax = q(i,1)
20     continue
       do 21 i = 1,n
       q(i,1) = qmax - q(i,1)
21     continue
       qmax = q(1,1)
       do 99 i = 2,n
       if (q(i,1).gt.qmax) qmax = q(i,1)
99     continue
       iqmax = qmax
       itmax = q(1,2)
       g1 = mod(iqmax,100)
       qmax = iqmax + 100 -g1
       g2 = mod(itmax,100)
       tmax = itmax + 100 -g2
       q1(1,1) = 0.
       q1(1,2) = 0.
       zincx = qmax/10.
       zincy = qmax/10.
       do 25 i = 2,11
       q1(i,1) = q1(i -1,1) + zincx
       q1(i,2) = q1(i-1,2) + zincy
25     continue
c      do 30 i = 1,11
c      do 40 j = 1,2
c      call rtc(q1(i,j),1,6,1,str(i,j))
c0     continue
c0     continue
       w1 = 60.0 * qmax /450.0
       w2 = 60.0 * tmax / 525.0
       wxmin = -w1
       wymin = -w2
       wxmax = qmax + w1
       wymax = tmax + w2
       call clsgr
       iqmax = qmax
       itmax = tmax
c      qtemp = (div(iqmax,100) + 1) * 100.0
c      ttemp = (div(itmax,100) + 1) * 100.0
       call daxis(qmax,tmax,wxmin,wymin,wxmax,wymax)
       call writer(2,30,gcc,21)
       x1 = q(1,1)
       y1 = q(1,2)
       call mapp(x1,y1,wxmin,wymin,wxmax,wymax)
       y1 = tform(x1,y1)
       ix1 = x1
       iy1 = y1
       call dmark(ix1,iy1)
       icolor = 4
       do 10 i = 2,n
       x2 = q(i,1)
       y2 = q(i,2)
       call mapp(x2,y2,wxmin,wymin,wxmax,wymax)
       y2 = tform(x2,y2)
       ix2 = x2
       iy2 = y2
       call line(ix1,iy1,ix2,iy2,icolor,0)
       ix1 = ix2
       iy1 = iy2
       call dmark(ix1,iy1)
       if (q(i,1).eq.0) then
       xtemp = qmax
       ytemp = q(i,2)
       call mapp(xtemp,ytemp,wxmin,wymin,wxmax,wymax)
       ytemp = tform(xtemp,ytemp)
       ix = xtemp
       iy = ytemp
       call line(ix1,iy1,ix,iy,6,0)
       call line(ix1,iy1+1,ix,iy+1,1,0)
       ixrow = (ix -100) / 8
       iycol = (iy + 28) / 14
c      call movcur(25,25)
c      write(*,*) ixrow,iycol
       call writer(iycol,ixrow,pnch,17)
       icolor = 1
       endif
10     continue
       temp1 = 'PRESS ENTER'
       call sglttr(temp1,11,tmp)
       call writer(24,68,tmp,11)
       call sread(ch)
       call cls
       return
       end


       subroutine mapp(x,y,xwmin,ywmin,xwmax,ywmax)
       xvmin = 25.
       yvmin = 25.
       xvmax = 600.
       yvmax = 360.
       x = xvmin + ((x - xwmin) / (xwmax - xwmin)) * (xvmax - xvmin)
       y = yvmin + ((y - ywmin) / (ywmax - ywmin)) * (yvmax - yvmin)
       return
       end


       function tform(x,y)
       tform = 350 -y
       return
       end

       subroutine daxis(xlen,ylen,xmin,ymin,xmax,ymax)
       character*1 xchar(7),tem(5)
       character*5 tempr
       tempr = 'Temp.'
       call sglttr(tempr,5,tem)
       call writer(11,2,tem,5)
       x1 = 0.0
       y1 = 0.0
       call mapp(x1,y1,xmin,ymin,xmax,ymax)
       x2 = xlen + 10.0
       y2 = ylen + 10.0
       call mapp(x2,y2,xmin,ymin,xmax,ymax)
       y1 = tform(x1,y1)
       y2 = tform(x2,y2)
       ix1 = x1
       iy1 = y1
       ix2 = x2
       iy2 = y2
       call line(ix1,iy1,ix2,iy1,1,0)
       call line(ix1,iy1+1,ix2,iy1+1,2,0)
       itempx = ix1
       itempy = iy1
       xval = 0.0
       do 10 i = 1,11
       call mark(itempx,itempy,0)
       ixpos = (itempy + 28) / 14
       iypos = (itempx - 5) / 8
       if (mod(i,2).eq.0) go to 210
       call rtochr(xval,xchar)
       call writer(ixpos,iypos,xchar,7)
210    xval = xval + xlen / 10.0
       itempx = itempx + (ix2 - ix1) /10
10     continue
       call line(ix1,iy1,ix1,iy2,3,0)
       call line(ix1+1,iy1,ix1+1,iy2,4,0)
       itempx = ix1
       itempy = iy1
       yval = 0.0
       do 20 i = 1,11
       call mark(itempx,itempy,1)
       ixpos = (itempy + 10)/ 14
       iypos = (itempx - 50) / 8
       if (mod(i,2).eq.0) go to 220
       call rtochr(yval,xchar)
       call writer(ixpos,iypos,xchar,7)
220    yval = yval + ylen / 10.0
       itempy = itempy + (iy2 - iy1) / 10
20     continue
       return
       end


       subroutine mark(ixpos,iypos,iaxis)
       if (iaxis .eq.0) go to 100
       ixlo = ixpos - 2
       ixhi = ixpos + 2
       iy = iypos
       call line(ixlo,iy,ixhi,iy,6,0)
       call line(ixlo,iy+1,ixhi,iy+1,6,0)
       go to 200
100    iylo = iypos - 2
       iyhi = iypos + 2
       ix = ixpos
       call line(ix,iylo,ix,iyhi,6,0)
       call line(ix+1,iylo,ix+1,iyhi,6,0)
200    return
       end

c      subroutine dmark gets a point x y which has already been mapped
c      through the window-vieport business and a marker is put there.
       subroutine dmark(ix,iy)
       call line(ix,iy-1,ix,iy+1,1,0)
       call line(ix-1,iy,ix+1,iy,2,0)
       call line(ix-1,iy-1,ix+1,iy+1,3,0)
       call line(ix-1,iy+1,ix+1,iy-1,4,0)
       return
       end


       subroutine rtochr(xval,xchar)
       character*1 xchar(7)
       tval = xval * 10.0
       itval = tval
       xchar(7) = char(mod(itval,10) + 48)
       xchar(6) = '.'
       i = 5
200    itval = itval / 10
       xchar(i) = char(mod(itval,10) + 48)
       if (itval.eq.0) go to 100
       i = i - 1
       go to 200
100    i = i + 1
       icount = i
       do 20 j = 1,8-i
       xchar(j) = xchar(i)
       i = i + 1
20     continue
       do 30 j = 9-icount,7
       xchar(j) = ' '
30     continue
       return
       end

